module fsm_template (
  input clk_i,
  input rst_i,
  /*
   * Declare your ports
   */
);

  // q is output of an FF, and d is input of an FF
  //     +----+
  // --->|D  Q|--->
  //     |    |
  // clk-|>   |
  //     +----+
  reg [/* bits you want */:0] state_q, state_d;

  parameter [/* bits you want */:0]
    state_name_0 = 2'b00,
    state_name_1 = 2'b01,
    .
    .
    . ;

  always @(posedge clk_i, /* active-high or active-low RESET*/ ) begin // filp-flop of your FSM
    if (/*rst_i or !rst_i*/) begin
      state_q <= /*initial state*/ ;
    end else begin
      state_q <= state_d ;
    end
  end

  /*** Please be full case ***/
  always @(*) begin // define next state, i.e. state_d in this block
    // you may write the default assignment here
    state_d = state_q;

    case (state_q)
      state_name_0 : begin
        if (/* some conditions are true */)
          state_d = /* next state */ ;
        else if (/* other conditions are true */)
          state_d = /* next state */ ;
      end

      state_name_1 : begin
        state_d = /* next state */;
      end

      /*
       * ... descriptions of other states
       */

      default: begin
        state_d = /* choose a defult state or state_q */;
      end
    endcase
  end

  /*** You can calculate any other signals based on current state ***/
  reg led;

  always @(*) begin
    // You must describe all possibilities of current state */
    if (state_q == state_name_0 || state_name_1) begin
      led = 1'b1;
    end else begin
      led = 1'b0;
    end
    // ... descriptions of other signals
  end

 endmodule
